/**
 * Collapse Sub Pages
 *
 * JavaScript to dynamically find and collapse child pages on
 * the Edit Pages page in wordpress admin.
 *
 * I am not a jQuery expert... don't judge me by my crappy code!
 */
 
jQuery(document).ready( function() {
	/**
	 * Stores all the id's of rows that are parents.
	 */
	var oParentRows = {};
	
	/*
	 * Hide all sub pages (children) at startup
	 */
	collapseAllSubPages();
	
	/*
	 * Add Expand/Collapse ALL Links to DOM
	 */
	jQuery('.subsubsub').append('<li class="expand_all_link"> | <a href="javascript:void(0);">Expand All</a></li><li class="collapse_all_link"> | <a href="javascript:void(0);">Collapse All</a></li>');
	
	/*
	 * Register Expand All Link
	 */
	jQuery(".expand_all_link a").click( function() {
		jQuery('#posts-filter table tr').each(function(){
			jQuery(this).show();
			toggleIcons(jQuery(this).find('.expand_link a'),true);
		});
	});
	
	/*
	 * Register Collapse All Link
	 */
	jQuery(".collapse_all_link a").click( function() {
		collapseAllSubPages();
	});
	
	/*
	 * Register Parent Expand/Collapse Links
	 */
	var sPageId;
	jQuery(".expand_link a").click( function() {
		sRowId	= jQuery(this).closest('tr').attr('id');
		sPageId	= sRowId.replace('page-','');
		
		jQuery('.post_parent').each(function(){
			if(jQuery(this).html() == sPageId) jQuery(this).closest('tr').toggle();
		});

		toggleIcons(this);
	});
	
	/**
	 * Collapse All Sub-pages on the page
	 *
	 * Wordpress didn't make it easy, did they?
	 */
	function collapseAllSubPages(){
		jQuery('.post_parent').each(function(){
			sParent = jQuery(this).html();
			sParentId = '#page-' + sParent;
			
			/*
			 * Check if this is a child AND the parent exists
			 */
			if(sParent != "0" && jQuery(sParentId).length != 0){
								
				/*
				 * Add link to parent if we haven't already
				 */
				if(sParentId in oParentRows){
					//do nothing
				}else{
					addParentRow([sParentId]);
					jQuery(sParentId).find('strong').append('<span class="expand_link"><a href="javascript:void(0);">[children]</a></span>');
				}//-if(sParentId in oParentRows)
				
				/*
				 * Collapse child
				 */
				jQuery(this).closest('tr').hide();
				
			}//-if(sParent != "0" && jQuery(sParentId).length > 0)
			
			/*
			 * Set "+" icon back
			 */
			jQuery(sParentId).find('.expand_link a').attr('class','');
			
		});//-jQuery('.post_parent').each(function()
		
	}//-function collapseAllSubPages()
	
	/**
	 * Toggle the +/- icons on the children links
	 */
	function toggleIcons(obj,bExpandAll){
		if(typeof bExpandAll == "undefined") bExpandAll = false;
		
		if('minus' == jQuery(obj).attr('class')){
			if(!bExpandAll) jQuery(obj).attr('class','');
		}else{
			jQuery(obj).addClass('minus');
		}
	}
		
	/**
	 * Update the object that holds parent row ids
	 *
	 * I know this is lame, but i really like if(x in z)
	 */
	function addParentRow(a){
		for(var i=0;i<a.length;i++){
			oParentRows[a[i]]=null;
		}
	}//-function addParentRow(a)

});